//
//  Simulation.m
//  Evolution
//
//  Created by Ivo Npflin.
//  Copyright (c) 2004 evo.naepflin.com. All rights reserved.
//

#import "Simulation.h"
#import "Tier.h"
#import "Feld.h"

@implementation Simulation

NSMutableArray *Tiere; 
NSMutableArray *Felder; 
BOOL prozessLauf;
int AnzahlFelderX;
int AnzahlFelderY;
int Rand;
int u, r, s, t, i, z;
int Zaehler;
//Steuerfunktionen
- (id)init
{
	Tiere = [[NSMutableArray alloc] init];
	//Tiere = [Tiere retain];
	Felder = [[NSMutableArray alloc] init];
	int Zaehler = 0;
			
			// Felder erstellen
	AnzahlFelderX = 100;	//Feldgrsse
	AnzahlFelderY = 100;
	AnzahlFelderX--;
	AnzahlFelderY--;
	

	for (r = 0; r <= AnzahlFelderX; r++)
	{
		NSMutableArray *Reihe = [[NSMutableArray alloc] init];
		for (s = 0; s <= AnzahlFelderY; s++)
			{
				if (r == 0 || r == AnzahlFelderX || s == 0 || s == AnzahlFelderY)
				{
					[Reihe addObject:[[Feld alloc] initAmRand:YES]];
				}
				else
				{
					[Reihe addObject:[[Feld alloc] initAmRand:NO]];
				}
			}
		[Felder addObject:Reihe];
		[Reihe release];
	}
	return self;
} 

- (id)starten:(id)sender
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	srand([[NSDate date] timeIntervalSince1970]);   //fr zufllige Zufallswerte ntig
	rand(); rand(); rand();
	prozessLauf = YES;
		
	
											//Prozess
	while (prozessLauf)
	{
		//Alle Tiere bewegen
		for (z = 0; z < [Tiere count]; z++)
		{
			[self ZugController:z];
			//Statistiken sollen hier noch gemacht werden.
		}
		
		//Alle Felder wachsen
		
		for (t = 0; t < AnzahlFelderX; t++)
		{
			NSMutableArray *Reihe;
			Reihe = [Felder objectAtIndex:t];

			for (u = 0; u < AnzahlFelderY; u++)
				{
					[[Reihe objectAtIndex:u] Wachsen];
				}
		}
	
	Zaehler++;

	}
	
	[pool release];
	
	return self;
}

- (id)anzeigen:(id)sender
{
	return self;
}

- (id)stoppen:(id)sender
{
	prozessLauf = NO;
	return self;
}


//Prozessfunktionen
- (id)ZugController:(int)TierID
{
	/*
	- 9 Zugmglichkeiten (inkl. stehen bleiben)
	- Aktivitten:
		- essen
		- schlafen
		- Tier tten
		- Fortpflanzung
	-----------------------
	36 Mglichkeiten
	*/

	int Array[9];
	int Gesamtpunktzahl;
	id gewaehltesTier = [self TierMitID:TierID];
	int StandortX = [gewaehltesTier StandortX];
	int StandortY = [gewaehltesTier StandortY];
	[gewaehltesTier Altern];
			//Energie fr Leben
	[gewaehltesTier Energieabnahme:1];

			//sterben
	if([gewaehltesTier Energiestand] < 0 || [gewaehltesTier Alter] > 100)
	{
		[[[Felder objectAtIndex:StandortX] objectAtIndex:StandortY] neuesTier:nil];
		[self TierStirbt:TierID];
		return self;
	}

	
	Array[0] = [[[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY-1] Anziehung];
	Array[1] = [[[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY+0] Anziehung];
	Array[2] = [[[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY+1] Anziehung];
	Array[3] = [[[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY-1] Anziehung];
	Array[4] = [[[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY+0] Anziehung];
	Array[5] = [[[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY+1] Anziehung];
	Array[6] = [[[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY-1] Anziehung];
	Array[7] = [[[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY+0] Anziehung];
	Array[8] = [[[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY+1] Anziehung];

	int Aggressivitaet = 10;		//Hunger soll hier einfliessen
	int Fortpflanzung = 0;
	Array[0] += [[[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY-1] TierDa] * (Aggressivitaet + Fortpflanzung);
	Array[1] += [[[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY+0] TierDa] * (Aggressivitaet + Fortpflanzung);
	Array[2] += [[[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY+1] TierDa] * (Aggressivitaet + Fortpflanzung);
	Array[3] += [[[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY-1] TierDa] * (Aggressivitaet + Fortpflanzung);
	Array[4] += [[[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY+0] TierDa] * (Aggressivitaet + Fortpflanzung);
	Array[5] += [[[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY+1] TierDa] * (Aggressivitaet + Fortpflanzung);
	Array[6] += [[[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY-1] TierDa] * (Aggressivitaet + Fortpflanzung);
	Array[7] += [[[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY+0] TierDa] * (Aggressivitaet + Fortpflanzung);
	Array[8] += [[[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY+1] TierDa] * (Aggressivitaet + Fortpflanzung);
	
	Gesamtpunktzahl = Array[0] + Array[1] + Array[2] + Array[3] + Array[4] + Array[5] + Array[6] + Array[7] + Array[8];
	if (Gesamtpunktzahl > 0)
	{
		Rand = Gesamtpunktzahl * ((float)rand() / RAND_MAX);
		
		if (Rand < Array[0])
		{
			[self Tier:gewaehltesTier mitID:TierID bewegtSichUmX:-1 UmY:-1];
			return self;
		}
		if (Rand < (Array[0] + Array[1]))
		{
			[self Tier:gewaehltesTier mitID:TierID bewegtSichUmX:-1 UmY:0];
			return self;
		}
		if (Rand < (Array[0] + Array[1] + Array[2]))
		{
			[self Tier:gewaehltesTier mitID:TierID bewegtSichUmX:-1 UmY:1];
			return self;
		}
		if (Rand < (Array[0] + Array[1] + Array[2] + Array[3]))
		{
			[self Tier:gewaehltesTier mitID:TierID bewegtSichUmX:0 UmY:-1];
			return self;
		}
		if (Rand < (Array[0] + Array[1] + Array[2] + Array[3] + Array[4]))
		{
			[self Tier:gewaehltesTier mitID:TierID bewegtSichUmX:0 UmY:0];
			return self;
		}
		if (Rand < (Array[0] + Array[1] + Array[2] + Array[3] + Array[4] + Array[5]))
		{
			[self Tier:gewaehltesTier mitID:TierID bewegtSichUmX:0 UmY:1];
			return self;
		}
		if (Rand < (Array[0] + Array[1] + Array[2] + Array[3] + Array[4] + Array[5] + Array[6]))
		{
			[self Tier:gewaehltesTier mitID:TierID bewegtSichUmX:1 UmY:-1];
			return self;
		}
		if (Rand < (Array[0] + Array[1] + Array[2] + Array[3] + Array[4] + Array[5] + Array[6] + Array[7]))
		{
			[self Tier:gewaehltesTier mitID:TierID bewegtSichUmX:1 UmY:0];
			return self;
		}
		
		[self Tier:gewaehltesTier mitID:TierID bewegtSichUmX:1 UmY:1];
		return self;
	}
	
	return self;
}

- (void)TiereAussetzenSim:(int)Anzahl
{
	int v;
	for (v = 0; v < Anzahl; v++)
	{
		[Tiere addObject:[[Tier alloc] initMitVater:nil Mutter:nil]];
	}
}



//Abfragefunktionen
- (int)AnzahlTiere
{
	return [Tiere count];
}
- (id)TierMitID:(int)ID
{
	return [Tiere objectAtIndex:ID];
}
- (int)Zaehler
{
	return Zaehler;
}


//Prozesshilfsfunktionen
- (id)Tier:(id)gewaehltesTier mitID:(int)TierID bewegtSichUmX:(int)VerschiebungX UmY:(int)VerschiebungY;
{	
		//Energie fr Bewegung
	if (VerschiebungX != 0 && VerschiebungY != 0)
	{
		[gewaehltesTier Energieabnahme:2];
	}
	
		//Bewegung
	int alterStandortX = [gewaehltesTier StandortX];
	int alterStandortY = [gewaehltesTier StandortY];
	[gewaehltesTier StandortWechselX:VerschiebungX WechselY:VerschiebungY];
	int StandortX = [gewaehltesTier StandortX];
	int StandortY = [gewaehltesTier StandortY];
	id ZielFeld = [[Felder objectAtIndex:StandortX] objectAtIndex:StandortY];
	

		//Bedingung fr Interaktion mit anderem Tier
	id ZweitesTier = [ZielFeld getTier];
	if (ZweitesTier != nil && ZweitesTier != gewaehltesTier && VerschiebungX != 0 && VerschiebungY !=0)
	{
		if ((1000 * (float)rand() / RAND_MAX) < ([gewaehltesTier PromillechanceAufFortpflanzung]))
		{
			[Tiere addObject:[[Tier alloc] initMitVater:gewaehltesTier Mutter:ZweitesTier]];
			[ZielFeld neuesTier:gewaehltesTier];
		}
		else
		{
			if ([gewaehltesTier Groesse]*[gewaehltesTier Geschwindigkeit]*[gewaehltesTier Energiestand] > [ZweitesTier Groesse]*[ZweitesTier Geschwindigkeit]*[ZweitesTier Energiestand])
			{		//gewaehltesTier (Angreifer) gewinnt
				[gewaehltesTier Energieabnahme:[ZweitesTier Groesse]*[ZweitesTier Energiestand]];
				[self TierStirbt:[Tiere indexOfObjectIdenticalTo:ZweitesTier]];
				[ZielFeld neuesTier:gewaehltesTier];
			}
			else
			{		//gewaehltesTier (Angreifer) verliert
				[ZweitesTier Energieabnahme:[gewaehltesTier Groesse]*[gewaehltesTier Energiestand]];
				[self TierStirbt:TierID];
				[[[Felder objectAtIndex:alterStandortX] objectAtIndex:alterStandortY] neuesTier:ZweitesTier];
			}
		}
	}
	
		//Weiden
	else
	{
		if ([ZielFeld Nutzung])
		{
			[gewaehltesTier Essen:[ZielFeld Anziehung]];
		}
		[ZielFeld neuesTier:gewaehltesTier];
	}

	[[[Felder objectAtIndex:alterStandortX] objectAtIndex:alterStandortY] neuesTier:nil];
	return self;
}
- (id)TierStirbt:(int)ID
{
	[Tiere removeObjectAtIndex:ID];
	return self;
}

- (id)Tier:(int)IDJaeger frisstTier:(int)IDOpfer;
{
	return self;
}


@end
